<?php
if($auth != 1)
{
	?>
	Извените, но загружать файлы могут только авторизованные пользователи;<br/>
	<br/>
	<img src='images/link.png' alt='&#187;'/> <a href='.'>Назад</a><br/>
	<?
	include 'includes/footer.inc';
	exit;
}

if(empty($_POST['save']))
{
	?>
	<form method='post' enctype='multipart/form-data' action='?module=upload'>
		<input type='hidden' name='save' value='true'/>
		
		Название?<br/>
		<input name='title' maxlength='100'/><br/>
		Описание?<br/>
		<textarea name='info'></textarea><br/>
		Файл?<br/>
		<input type='file' name='object'/><br/>
		Раздел?<br/>
		<select name='category'>
			<option value='1'>картинки, анимации</option>
			<option value='2'>музыка, звуки</option>
			<option value='3'>видео, ролики</option>
			<option value='4'>темы, скины</option>
			<option value='5'>игры, софт, другое</option>	
			<option value='6'>XXX картинки</option>
			<option value='7'>XXX видео</option>
		</select><br/>
		<input type='submit' value='Загрузить'/><br/>
	</form>
	<br/>
	<img src='images/link.png' alt='&#187;'/> <a href='.'>Назад</a><br/>
	<?
}
else
{
	$err = '';
	
	$title = clear($_POST['title']);
	$info2 = clear($_POST['info']);
	$category = intval($_POST['category']);
		
	if(empty($title) OR empty($info2) OR empty($category)) $err .= 'Заполнены не все поля;<br/>';
	if(strlen($title) > 200) $err .= 'Название может содержать до 100 символов;<br/>';
	if(strlen($info2) > 1024) $err .= 'Описание может содержать до 512 символов;<br/>';
	if($category != 1 AND $category != 2 AND $category != 3 AND $category != 4 AND $category != 5 AND $category != 6 AND $category != 7) $err .= 'Не выбрана категория;<br/>';
	
	
	$pictures = array('.gif', '.jpg', '.jpeg', '.bmp', '.png', '.wbmp', '.pic', '.ani', '.pco');
	$audio = array('.mmf', '.mid', '.amr', '.mp3', '.wav', '.aac', '.seq', '.vox', '.dxm', '.imy', '.emy', '.pmd', '.rng');
	$video = array('.3gp', '.mp4', '.avi', '.mpeg', '.rm');
	$themes = array('.zip', '.sis', '.sisx', '.thm', '.sdt', '.nth', '.mtf', '.col', '.scs', '.utz');
	$other = array('.zip', '.rar', '.cab', '.sis', '.sisx', '.jar', '.jad');
	
	$ext = strtolower(strrchr($_FILES['object']['name'], '.'));

	if(in_array($ext, $pictures)) $type = 1;
	if(in_array($ext, $audio)) $type = 2;
	if(in_array($ext, $video)) $type = 3;
	if(in_array($ext, $themes)) $type = 4;
	if(in_array($ext, $other)) $type = 5;
	if($category == 6 AND in_array($ext, $pictures)) $type = 6;
	if($category == 7 AND in_array($ext, $video)) $type = 7;

	$ftype = explode('/', $_FILES['object']['type']);
	$ftype = $ftype[0];
	
	if($category != $type) $err .= 'Вы выбрали не верную категорию для файла;<br/>';

	if($type == 1 AND $ftype != 'image') $err .= 'Это не картинка;<br/>';
	if($type == 2 AND $ftype != 'audio') $err .= 'Это не аудио;<br/>';
	if($type == 3 AND $ftype != 'video') $err .= 'Это не видео;<br/>';
	if($type == 4 AND $ftype != 'application') $err .= 'Это не тема;<br/>';
	if($type == 5 AND $ftype != 'application') $err .= 'Это не игра и не софт и...;<br/>';
	
	if($_FILES['object']['size'] > (1024 * 1024) * 5) $err .= 'Размер файла не должен превышать 5 мегабайт;<br/>';

		function good_filename($source)
		{
			$tr = array('Ґ' => 'G', 'Ё' => 'YO', 'Є' => 'E', 'Ї' => 'YI', 'І' => 'I', 'і' => 'i', 'ґ' => 'g', 'ё' => 'yo', '№' => '#', 'є' => 'e', 'ї' => 'yi', 'А' => 'A', 'Б' => 'B', 'В' => 'V', 'Г' => 'G', 'Д' => 'D', 'Е' => 'E', 'Ж' => 'ZH', 'З' => 'Z', 'И' => 'I', 'Й' => 'Y', 'К' => 'K', 'Л' => 'L', 'М' => 'M', 'Н' => 'N', 'О' => 'O', 'П' => 'P', 'Р' => 'R', 'С' => 'S', 'Т' => 'T', 'У' => 'U', 'Ф' => 'F', 'Х' => 'H', 'Ц' => 'TS', 'Ч' => 'CH', 'Ш' => 'SH', 'Щ' => 'SCH', 'Ъ' => '', 'Ы' => 'YI', 'Ь' => '', 'Э' => 'E', 'Ю' => 'YU', 'Я' => 'YA', 'а' => 'a', 'б' => 'b', 'в' => 'v', 'г' => 'g', 'д' => 'd', 'е' => 'e', 'ж' => 'zh', 'з' => 'z', 'и' => 'i', 'й' => 'y', 'к' => 'k', 'л' => 'l', 'м' => 'm', 'н' => 'n', 'о' => 'o', 'п' => 'p', 'р' => 'r', 'с' => 's', 'т' => 't', 'у' => 'u', 'ф' => 'f', 'х' => 'h', 'ц' => 'ts', 'ч' => 'ch', 'ш' => 'sh', 'щ' => 'sch', 'ъ' => '', 'ы' => 'yi', 'ь' => '', 'э' => 'e', 'ю' => 'yu', 'я' => 'ya');
			$source = strtr($source, $tr); 
			$source = strtolower($source); 
			$source = str_replace(' ', '_', $source); 
			$source = preg_replace("/[^\w^\.\x7F-\xFF\s]/", '', $source); 
			$source = time().$source;
			
			return $source;
		}
		
		$name = good_filename($_FILES['object']['name']); # имя файла

		$query = @mysql_query("SELECT `id` FROM `files` WHERE `title` = '$title' AND `info` = '$info2';");
		if(@mysql_affected_rows() > 0) $err .= 'Такой файл уже существует;<br/>';

		$query = @mysql_query("SELECT `id` FROM `files` WHERE `author` = '$id' AND `time` > '".(time() - $config['spam'])."';");
		if(@mysql_affected_rows() > 0) $err .= 'Вы не можете так часто добавлять файлы;<br/>';

	if($err != '')
	{
		echo $err;
		?>
		<br/>
		<img src='images/link.png' alt='&#187;'/> <a href='?module=upload'>Назад</a><br/>
		<?
	}
	else
	{		
		if($type == 1) $type = 'pictures';
		if($type == 2) $type = 'music';
		if($type == 3) $type = 'video';
		if($type == 4) $type = 'themes';
		if($type == 5) $type = 'other';

		if($category == 6) $type = 'xxx-pictures';
		if($category == 7) $type = 'xxx-video';
		
		
		if($category == 6 OR $category == 7)
			$xxx = 1;
		else
			$xxx = 0;
		
		
		$size = $_FILES['object']['size'];
		
		if(@mysql_query("INSERT INTO `files` (`type`, `url`, `title`, `info`, `time`, `clicks`, `ltime`, `author`, `xxx`) VALUES ('$type', '$name', '$title', '$info2', '".time()."', '0', '".time()."', '$id', '$xxx');") AND @copy($_FILES['object']['tmp_name'], 'files/'.$type.'/'.$name))
		{
			$allsize = $info['allsize'] + ($size / 1024);
			@mysql_query("UPDATE `users` SET `allfiles` = `allfiles` + 1, `allsize` = '$allsize' WHERE `id` = '$id';");
			?>
			Файл добавлен;<br/>
			<br/>
			<img src='images/link.png' alt='&#187;'/> <a href='.'>Продолжить</a><br/>
			<?
		}
		else
		{
			@mysql_query("DELETE FROM `files` WHERE `url` = '$name';");
			?>
			Ошибка MySQL;<br/>
			<br/>
			<img src='images/link.png' alt='&#187;'/> <a href='?module=upload'>Назад</a><br/>
			<?
		}	
	}
}
?>